(function( GOGINFO ){

    if ( !GOGINFO ) {
        return;
    }

    /** wrapping GA functions */
    window.ga = function() {
        if ( typeof window.gan === 'function' ) {
            window.gan.apply( window, arguments );
        }
        if ( typeof window.gtag === 'function' && arguments[0] === 'send' && arguments[1] === 'event' ) {
            window.gtag( 'event', arguments[3], {
                event_category: arguments[2],
                event_label: arguments[4],
            } );
        }
    };

    /** create the head script elements */
    var createDocumentElements = function( s, o, g, a, m ) {
        //noinspection CommaExpressionJS
        a = s.createElement(o),
        m = s.getElementsByTagName(o)[0];
        a.async = 1;
        a.src = g;
        m.parentNode.insertBefore(a, m)
    };

    if (GOGINFO.gtagId) {
        /* Global site tag (gtag.js) - Google Analytics */
        (function(i, s, o, g, r, d) {
            //noinspection CommaExpressionJS
            i[r] = i[r] || function() {
                (i[d] = i[d] || []).push(arguments);
            };
            createDocumentElements( s, o, g );
        })(window, document, 'script', 'https://www.googletagmanager.com/gtag/js?id=' + GOGINFO.gtagId, 'gtag', 'dataLayer');

        gtag('js', new Date());
        gtag('config', GOGINFO.gtagId);
    }

    if (GOGINFO.trackingId) {
        /* default google tracking initialization */
        (function(i, s, o, g, r ) {
            i['GoogleAnalyticsObject'] = r;
            //noinspection CommaExpressionJS
            i[r] = i[r] || function() {
                (i[r].q = i[r].q || []).push(arguments)
            }, i[r].l = 1 * new Date();
            //noinspection CommaExpressionJS
            createDocumentElements( s, o, g );
        })(window, document, 'script', 'https://www.google-analytics.com/analytics.js', 'gan');
	
	    // initalize and set options
	    ga('create', GOGINFO.trackingId, 'auto', GOGINFO.options);
	    ga('set', 'forceSSL', true);
	    ga('set', 'anonymizeIp', GOGINFO.anonymizeIp);
	}

    // track pageview and action
    // ga('send', 'pageview', GOGINFO.pageview || location.pathname);

    function googleAnalytics ( $rootScope ) {
        $rootScope.$on('$locationChangeSuccess', function( newURL ) {
            // track pageview and action
            ga('set', 'page', location.pathname);
            ga('send', 'pageview' );
        });
    };

    googleAnalytics.$inject = ['$rootScope'];
    clearreportsApp.run(googleAnalytics);
    
})(window.GOGINFO);
